import java.util.Random;
import processing.core.*;

// This is our robot class
public class Robot{
  /*
  private int x;
  private int y;
  */
  private Vector2d location;
  private Vector2d velocity;
  private Vector2d acceleration;
  
  int speed;
  int diameter;
  
  static Random rng = new Random();
  
  public Robot(int x0, int y0, int size, int speed){
    /* this.x = x0;
    this.y = y0;
    */
    this.location = new Vector2d((double)x0,(double)y0);
    this.velocity = new Vector2d(0,0);
    this.acceleration = new Vector2d(0,0);
    
    this.diameter = size;
    this.speed = speed;
  }
  
  // This doesn't work because we don't have a reference 
  // of a place to draw! Where is the ellipse going to be drawn?
  /*public void render(){
     ellipse(this.x, this.y
             , this.diameter, this.diameter);  
  }*/
  
  public int getX(){
    // this makes the method return a
    // random number between x-speed and x+speed
    int x_noise = rng.nextInt(speed)-speed/2;
    return (int)location.x + x_noise; 
  }
  
  public int getY(){
    // this makes the method return a
    // random number between x-speed and x+speed
    int y_noise = rng.nextInt(speed)-speed/2;
    return (int)location.y + y_noise;
  }
  
  public void update(){
     // use the robots velocity, to update its location
     location.add(velocity);
     velocity.add(acceleration);
     // this will remove some energy form the robots
     velocity.multiply(0.9);
     
     acceleration.multiply(0);
  }  
  
  public void applyForce(int sourcex, int sourcey, boolean isRepulsive){
      Vector2d source = new Vector2d((double)sourcex,(double)sourcey);
      source.multiply(-1);
      
      Vector2d force = new Vector2d(location.x,location.y);
      force.add(source);
      if (isRespulsive){
        force.multiply(0.001);
      } else {
        force.multiply(-0.001);
      }   
      // F = m * a... assume the m equals to 1
      acceleration.add(force);
  } 
}
